﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Management;
using Microsoft.Office.Interop;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;

namespace mook_HardwareInfo
{
    public partial class Form1 : Form
    {
        Thread ExcelSave = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            foreach (string property in XmlSetup.GetWMIs("WMI"))
            {
                try { this.cbbWmiName.Items.Add(property);}
                catch (SystemException) { /* ignore error */ }
            }
        }

        private void cbbWmiName_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.cbbWmiName.SelectedItem.ToString() != "")
            {
                this.lvWmiView.Items.Clear();
                var _query = new SelectQuery(this.cbbWmiName.SelectedItem.ToString());
                var _search = new ManagementObjectSearcher(_query);

                foreach (ManagementObject _info in _search.Get())
                {
                    this.lvWmiView.Groups.Add(_info.ToString(), 
                        _info.Properties["Name"].Value.ToString());
                    
                    foreach(PropertyData tmpOB in _info.Properties)
                    {
                        string _val = "";
                        if (tmpOB.Value != null) _val = tmpOB.Value.ToString();
                        string[] strArray = { tmpOB.Name, _val };
                        var lvItem = new ListViewItem(strArray);
                        lvItem.Group = (ListViewGroup)lvWmiView.Groups[_info.ToString()];
                        lvWmiView.Items.Add(lvItem);
                    }
                }
                this.btnExcel.Enabled = true;
            }
        }

        private void btnExcel_Click(object sender, EventArgs e)
        {
            if (this.cbbWmiName.Text == "")
            { return; }
            else
            {
                if (this.sfdExcel.ShowDialog() == DialogResult.OK)
                {
                    ExcelSave = new Thread(ExcelWrite);
                    ExcelSave.Start();
                }
            }
        }
        private void ExcelWrite()
        {
            try
            {
                object missingType = Type.Missing;
                Microsoft.Office.Interop.Excel.Application excelApp = 
                    new Microsoft.Office.Interop.Excel.Application();
                Microsoft.Office.Interop.Excel.Workbook excelBook = 
                    excelApp.Workbooks.Add(missingType);
                Microsoft.Office.Interop.Excel.Worksheet excelworksheet =
                    (Microsoft.Office.Interop.Excel.Worksheet)excelBook.Worksheets.Add(
                    missingType, missingType, missingType, missingType);
                excelworksheet.Name = this.cbbWmiName.SelectedItem.ToString();

                excelworksheet.Cells[1, 1] = this.lvWmiView.Columns[0].Text;
                excelworksheet.Cells[1, 2] = this.lvWmiView.Columns[1].Text;

                var _query = new SelectQuery(this.cbbWmiName.SelectedItem.ToString());
                var _search = new ManagementObjectSearcher(_query);

                int i = 2;
                foreach (ManagementObject _info in _search.Get())
                {
                    excelworksheet.get_Range("A" + i, "B" + i).MergeCells = true;
                    excelworksheet.get_Range("A" + i, "B" + i).Value = 
                        _info.Properties["Name"].Value.ToString();
                    i++;
                    foreach (PropertyData tmpOB in _info.Properties)
                    {
                        string _val = "";
                        if (tmpOB.Value != null) _val = tmpOB.Value.ToString();
                        excelworksheet.Cells[i, 1] = tmpOB.Name;
                        excelworksheet.Cells[i, 2] = _val;
                        i++;
                    }
                }

                excelBook.SaveAs(this.sfdExcel.FileName);
                excelBook.Close();
                excelApp.Quit();

                Marshal.ReleaseComObject(excelBook);
                Marshal.ReleaseComObject(excelworksheet);
                Marshal.ReleaseComObject(excelApp);

                var _File = new FileInfo(this.sfdExcel.FileName);
                if (_File.Exists == true)
                    MessageBox.Show("파일이 정상적으로 생성되었습니다.", 
                        "알림", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception m)
            {
                MessageBox.Show("오류발생 : " + m);
            }
            finally
            { ExcelSave.Abort(); }
        }
    }
}
