﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using System.Threading;

namespace mook_HexEditor
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private string fileName = "";
        Thread HexAnalysis = null;

        private void btnFile_Click(object sender, EventArgs e)
        {
            if (this.ofdFile.ShowDialog() == DialogResult.OK)
            {
                fileName = ofdFile.FileName;
                this.HexView.Text = "";
            }
            ofdFile.Dispose();
            int fsize = getFileSize(fileName);
            if (fsize > 0)
            {
                HexAnalysis = new Thread(new ParameterizedThreadStart(hexEditor));
                HexAnalysis.Start(fileName + "?" + fsize);
            }
            else
            {
                this.HexView.AppendText("\n 파일 선택이 잘 못 되었습니다. \n");
            }
        }

        private int getFileSize(string inFile)
        {
            long size = -1;
            try
            {
                FileInfo fi = new FileInfo(inFile);
                size = fi.Length;
                if (size > 2147483640)
                {
                    return -1;
                }
                else
                {
                    return (int)size;
                }
            }
            catch
            {
                return -1;
            }
        }

        private void hexEditor(object _inFileinSize)
        {
            var inFile = _inFileinSize.ToString().Split('?')[0];
            int inSize = Convert.ToInt32(_inFileinSize.ToString().Split('?')[1]);

            StringBuilder biglocal = new StringBuilder();
            StringBuilder sblocal = new StringBuilder();

            string message = "\n " + fileName + " " + (int)inSize + " bytes\n\n";
            this.HexView.AppendText(message);
            stbView.Text = " " + fileName + " " + (int)inSize + " bytes";
            this.HexView.Update();

            FileStream fs;
            byte[] MyData;
            try
            {
                fs = new FileStream
                    ((string)inFile, FileMode.OpenOrCreate, FileAccess.Read);
                MyData = new byte[fs.Length];
            }
            catch
            {
                this.HexView.AppendText("\n 파일 분석에 오류가 발생하였습니다.\n\n");
                return;
            }

            stbView.Text = "하드 디스크 파일 분석";
            fs.Read(MyData, 0, (int)fs.Length);
            fs.Close();

            int newrow = 0; //라인
            int global = 0; //Offset 넘버링
            string hex = " "; //hex 값
            string numb = " "; //offset 값

            this.pgbView.Maximum = MyData.Length;
            this.pgbView.Value = 0;

            stbView.Text = "메모리 영역 분석";
            for (int i = 0; i < MyData.Length; ++i)
            {
                if (i % 1000 == 0)
                {
                    this.pgbView.Value = i;
                }

                if (newrow == 0)
                {
                    numb = padZeros(global);
                    biglocal.Append(" " + numb + " ");
                    global += 16;
                }

                hex = convertByteToHexString(MyData[i]);
                biglocal.Append(" " + hex);	// 3 characters

                int g = MyData[i];
                if (g > 13 || (g > 0 && g < 9))
                {
                    sblocal.Append((char)MyData[i]);
                }
                else
                {
                    sblocal.Append(".");
                }

                ++newrow;
                if (newrow >= 16)
                {
                    biglocal.Append("   " + sblocal.ToString() + "\n");
                    sblocal = new StringBuilder();	
                    newrow = 0;						
                }
            }

            if (newrow > 0 && newrow < 16)
            {
                for (int i = 0; i < (16 - newrow); ++i)
                {
                    biglocal.Append("   ");
                }
                biglocal.Append("   " + sblocal);
            }
            biglocal.Append("\n\n");
            stbView.Text = "Hex 값을 쓰기";
            this.HexView.AppendText(biglocal.ToString());
            stbView.Text = "작업 완료";
            this.pgbView.Value = MyData.Length;
            HexAnalysis.Abort();
        }

        private string padZeros(int inInt)
        {
            StringBuilder sblocal = new StringBuilder();
            string hex = Convert.ToString(inInt, 16);
            if (hex.Length < 8)
            {
                int ix = 8 - hex.Length;
                for (int i = 0; i < ix; ++i)
                {
                    sblocal.Append("0");
                }
            }
            sblocal.Append(hex);
            return sblocal.ToString().ToUpper();
        }

        public string convertByteToHexString(byte inByte)
        {
            StringBuilder sblocal = new StringBuilder();
            string hex = Convert.ToString(inByte, 16);
            if (hex.Length == 1)
            {
                sblocal.Append("0");
                sblocal.Append(hex);
            }
            else
            {
                sblocal.Append(hex);
            }
            return sblocal.ToString().ToUpper();
        }
    }
}
