﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;
using System.Security.Cryptography;

namespace mook_FileHash
{
    class HashConvert
    {
		private static FileStream GetFileStream(string pathName)
		{
			return(new FileStream(pathName, FileMode.Open, 
                FileAccess.Read, FileShare.ReadWrite));
		}

        public static string GetSHA1Hash(string pathName)
		{
			string strResult = "";
			string strHashData = "";

			byte[] arrbytHashValue;
			FileStream oFileStream = null;

			SHA1CryptoServiceProvider oSHA1Hasher = 
                new SHA1CryptoServiceProvider();

			try
			{
				oFileStream = GetFileStream(pathName);
				arrbytHashValue = oSHA1Hasher.ComputeHash(oFileStream);
				oFileStream.Close();
				strHashData = BitConverter.ToString(arrbytHashValue);
				strHashData = strHashData.Replace("-", "");
				strResult = strHashData;
			}
			catch(Exception ex)
			{
				MessageBox.Show("에러 발생 : " +  ex.Message, "에러", 
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
            return strResult;
		}

        public static string GetMD5Hash(string pathName)
		{
			string strResult = "";
			string strHashData = "";

			byte[] arrbytHashValue;
			FileStream oFileStream = null;

			MD5CryptoServiceProvider oMD5Hasher = 
                new MD5CryptoServiceProvider();

			try
			{
				oFileStream = GetFileStream(pathName);
				arrbytHashValue = oMD5Hasher.ComputeHash(oFileStream);
				oFileStream.Close();

				strHashData = BitConverter.ToString(arrbytHashValue);
				strHashData = strHashData.Replace("-", "");
				strResult = strHashData;
			}
			catch(System.Exception ex)
			{
				MessageBox.Show("에러 발생 : " + ex.Message, "에러", 
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
            return strResult;
		}
    }
}
