﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Security.Cryptography;
using System.Threading;
using System.Xml.Serialization;

namespace mook_RSA
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public delegate void UpdateTextDelegate(string inputText);
        RSACryptoServiceProvider RSAProvider = new RSACryptoServiceProvider(1024);

        private void UpdateText(string inputText)
        { this.txtDecrypt.Text = inputText; }

        private void exitXToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void publicKeyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sfdFile.Filter = "Public Key Document( *.pke )|*.pke";
            if (sfdFile.ShowDialog() == DialogResult.OK)
            {
                
                string PrivateKeys = RSAProvider.ToXmlString(false);
                try
                {
                    StreamWriter streamWriter = new StreamWriter(sfdFile.FileName, false);
                    if (PrivateKeys != null)
                    { streamWriter.Write(PrivateKeys); }
                    streamWriter.Close();
                }
                catch (Exception Ex)
                {
                    MessageBox.Show(Ex.Message);
                }
            }
        }

        private void privateKeyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sfdFile.Filter = "Private Keys Document( *.kez )|*.kez";
            if (sfdFile.ShowDialog() == DialogResult.OK)
            {
                string PrivateKeys = RSAProvider.ToXmlString(true);
                try
                {
                    StreamWriter streamWriter = new StreamWriter(sfdFile.FileName, false);
                    if (PrivateKeys != null)
                    { streamWriter.Write(PrivateKeys); }
                    streamWriter.Close();
                }
                catch (Exception Ex)
                {
                    MessageBox.Show(Ex.Message);
                }
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            ofdFile.Filter = "Public Key Document( *.pke )|*.pke";
            if (ofdFile.ShowDialog() == DialogResult.OK)
            {
                sfdFile.Filter = "Public Key Document( *.pke )|*.pke";
                if (sfdFile.ShowDialog() == DialogResult.OK)
                {
                    FileInfo fi = new FileInfo(this.ofdFile.FileName);
                    fi.CopyTo(this.sfdFile.FileName);
                }
            }
        }

        private void btnGetFile_Click(object sender, EventArgs e)
        {
            ofdFile.Filter = "Text File( *.txt )|*.txt";
            if (this.ofdFile.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    StreamReader streamReader = new StreamReader(this.ofdFile.FileName);
                    this.txtMessage.Text = streamReader.ReadToEnd();
                    streamReader.Close();
                }
                catch (Exception Ex)
                {
                    MessageBox.Show(Ex.Message);
                }
            }
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            string fileString = null;
            ofdFile.Filter = "Private Keys Document( *.kez )|*.kez";
            if (this.ofdFile.ShowDialog() == DialogResult.OK)
            {
                StreamReader sr = new StreamReader(this.ofdFile.FileName, true);
                fileString = sr.ReadToEnd();
                sr.Close();
            }

            if (fileString != null)
            {
                UpdateTextDelegate updateTextDelegate = new UpdateTextDelegate(UpdateText);
                int bitNum = 1024;

                try
                {
                    DecryptionThread decThread = new DecryptionThread();
                    Thread decryptThread = new Thread(decThread.Decrypt);
                    decryptThread.IsBackground = true;
                    decryptThread.Start(new Object[] { this, updateTextDelegate, this.txtMessage.Text, bitNum, fileString });
                }
                catch (Exception Ex)
                { MessageBox.Show("에러 발생 : " + Ex.Message); }
            }
        }
    }
}
