﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using System.Threading;
using System.Windows.Forms;
using System.Security.Cryptography;

namespace mook_RSAUser
{
    class EncryptionThread
    {
        private ContainerControl containerControl = null;
        private Delegate updateTextDelegate = null;

        public void Encrypt(object inputObject)
        {
            object[] inputObjects = (object[])inputObject;
            containerControl = (Form)inputObjects[0];
            updateTextDelegate = (Delegate)inputObjects[1];
            string encryptedString = EncryptString((string)inputObjects[2], (int)inputObjects[3], (string)inputObjects[4]);
            containerControl.Invoke(updateTextDelegate, new object[] { encryptedString });
        }


        public string EncryptString(string inputString, int dwKeySize, string xmlString)
        {
            RSACryptoServiceProvider rsaCryptoServiceProvider = new RSACryptoServiceProvider(dwKeySize);
            rsaCryptoServiceProvider.FromXmlString(xmlString);
            int keySize = dwKeySize / 8;
            byte[] bytes = Encoding.UTF32.GetBytes(inputString);
            int maxLength = keySize - 42;
            int dataLength = bytes.Length;
            int iterations = dataLength / maxLength;
            StringBuilder stringBuilder = new StringBuilder();
            for (int i = 0; i <= iterations; i++)
            {
                byte[] tempBytes = new byte[(dataLength - maxLength * i > maxLength) ? maxLength : dataLength - maxLength * i];
                Buffer.BlockCopy(bytes, maxLength * i, tempBytes, 0, tempBytes.Length);
                byte[] encryptedBytes = rsaCryptoServiceProvider.Encrypt(tempBytes, true);
                Array.Reverse(encryptedBytes);
                stringBuilder.Append(Convert.ToBase64String(encryptedBytes));
            }
            return stringBuilder.ToString();
        }
    }
}