﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace mook_Rijndael
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string FilePath = null;
        byte[] PrivateKey = null; //16,24,32 중
        byte[] PrivateIV = null; // 16자리

        private void btnFile_Click(object sender, EventArgs e)
        {
            if (this.ofdFile.ShowDialog() == DialogResult.OK)
            {
                FilePath = this.ofdFile.FileName;
                StreamReader sr = new StreamReader(FilePath, 
                    System.Text.Encoding.Default);
                this.txtDiary.Text = sr.ReadToEnd();
                sr.Close();
            }
        }

        private void btnConvert_Click(object sender, EventArgs e)
        {
            if(this.txtPrivateKey.Text == "" || this.txtPrivateKey.Text.Length < 8)
            {
                MessageBox.Show("PrivateKey 입력이 올바르지 않습니다.", "알림",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.txtPrivateKey.Focus();
                return;
            }
            string strkey = this.txtPrivateKey.Text + this.txtPrivateKey.Text 
                + this.txtPrivateKey.Text + this.txtPrivateKey.Text;
            PrivateKey = Encoding.ASCII.GetBytes(strkey);
            byte[] arrIv = Encoding.ASCII.GetBytes(this.txtPrivateKey.Text 
                + this.txtPrivateKey.Text);
            System.Array.Reverse(arrIv);
            PrivateIV = arrIv;

            try
            {
                MemoryStream msDecrypt = null;
                CryptoStream csDecrypt = null;
                StreamReader srDecrypt = null;
                RijndaelManaged aesAlg = null;

                string plaintext = null;

                aesAlg = new RijndaelManaged();
                aesAlg.Key = PrivateKey;
                aesAlg.IV = PrivateIV;


                ICryptoTransform decryptor = aesAlg.CreateDecryptor(aesAlg.Key, aesAlg.IV);

                byte[] cipherText = Convert.FromBase64String(this.txtDiary.Text);

                msDecrypt = new MemoryStream(cipherText);
                csDecrypt = new CryptoStream(msDecrypt, decryptor, CryptoStreamMode.Read);
                srDecrypt = new StreamReader(csDecrypt);
                plaintext = srDecrypt.ReadToEnd();

                if (srDecrypt != null) srDecrypt.Close();
                if (csDecrypt != null) csDecrypt.Close();
                if (msDecrypt != null) msDecrypt.Close();
                if (aesAlg != null) aesAlg.Clear();

                this.txtDiary.Text = plaintext;
            }
            catch
            {
                MessageBox.Show("복호화 장애가 발생하였습니다.", "알림", MessageBoxButtons.OK,
                    MessageBoxIcon.Information);
                return;
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (this.txtPrivateKey.Text == "" || this.txtPrivateKey.Text.Length < 8)
            {
                MessageBox.Show("PrivateKey 입력이 올바르지 않습니다.", "알림",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.txtPrivateKey.Focus();
                return;
            }
            if(this.sfdFile.ShowDialog() == DialogResult.OK)
            {
                string saveFilePath = this.sfdFile.FileName;
                StreamWriter sw = new StreamWriter(saveFilePath, false, Encoding.Default);
                sw.Write(StringEncrypt());
                sw.Flush();
                sw.Close();
            }
        }

        private string StringEncrypt()
        {
            string strkey = this.txtPrivateKey.Text + this.txtPrivateKey.Text 
                + this.txtPrivateKey.Text + this.txtPrivateKey.Text;
            PrivateKey = Encoding.ASCII.GetBytes(strkey);
            byte[] arrIv = Encoding.ASCII.GetBytes(this.txtPrivateKey.Text 
                + this.txtPrivateKey.Text);
            System.Array.Reverse(arrIv);
            PrivateIV = arrIv;

            MemoryStream msEncrypt = null;
            CryptoStream csEncrypt = null;
            StreamWriter swEncrypt = null;
            RijndaelManaged aesAlg = null;

            aesAlg = new RijndaelManaged();

            aesAlg.Key = PrivateKey;
            aesAlg.IV = PrivateIV;
            
            ICryptoTransform encryptor = aesAlg.CreateEncryptor(aesAlg.Key, aesAlg.IV);

            msEncrypt = new MemoryStream();
            csEncrypt = new CryptoStream(msEncrypt, encryptor, CryptoStreamMode.Write);
            swEncrypt = new StreamWriter(csEncrypt);

            swEncrypt.Write(this.txtDiary.Text);

            if (swEncrypt != null) swEncrypt.Close();
            if (csEncrypt != null) csEncrypt.Close();
            if (msEncrypt != null) msEncrypt.Close();
            if (aesAlg != null) aesAlg.Clear();

            return Convert.ToBase64String(msEncrypt.ToArray());
        }
    }
}
