﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net.NetworkInformation;

namespace mook_NetCheck
{
    public partial class Form1 : Form
    {
        Ping pingSender = new Ping();
        PingOptions options = new PingOptions();
        string data = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
        const int timeout = 120;


        public Form1()
        {
            InitializeComponent();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            this.lbAddress.Items.Add(this.txtAddress.Text);
        }

        private void lbAddress_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.lbAddress.SelectedItems.Count > 0)
                this.btnCheck.Enabled = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.cbTime.Text = "1초";
        }

        private void btnCheck_Click(object sender, EventArgs e)
        {
            if (this.lbAddress.SelectedItems.Count == 0)
            {
                MessageBox.Show("체크할 IP를 선택하세요", "알림",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            if (this.btnCheck.Text == "체크")
            {
                this.Timer.Enabled = true;
                this.lbAddress.Enabled = false;
                this.btnCheck.Text = "중지";
            }
            else
            {
                this.Timer.Enabled = false;
                this.lbAddress.Enabled = true;
                this.btnCheck.Text = "체크";
            }
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            PingCheck();
        }

        private void PingCheck()
        {
            try 
            {
                Byte[] buffer = Encoding.ASCII.GetBytes(data);
                options.DontFragment = true;

                foreach(var args in this.lbAddress.SelectedItems)
                {
                    PingReply reply = pingSender.Send(args.ToString(), 
                        timeout, buffer, options);
                    string _lbResult = null;
                    if (reply.Status == IPStatus.Success)
                    {
                        _lbResult = args.ToString() + " 아이피 " + 
                            DateTime.Now + " " + " Reply Form " + 
                            args.ToString() + " bytes=" + 
                            reply.Buffer.Length.ToString() + " bytes=" 
                            + reply.RoundtripTime.ToString() + " TTL=" 
                            + reply.Options.Ttl.ToString();
                        this.lbResult.Items.Add(_lbResult);
                    }
                    else
                    {
                        this.lbResult.Items.Add(args.ToString() 
                            + " 아이피 확인실패");
                    }
                }
                this.lbResult.Items.Add("");
                if (this.lbResult.Items.Count + 5 > this.lbAddress.Items.Count * 10)
                    this.lbResult.Items.Clear();
            }
            catch(Exception ex)
            {
                MessageBox.Show("네트워크 장애 : " + ex.ToString(), 
                    "에러 알림", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void cbTime_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (this.cbTime.Text)
            {
                case "1초":
                    this.Timer.Interval = 1000;
                    break;
                case "2초": 
                    this.Timer.Interval = 2000; 
                    break; 
                case "3초": 
                    this.Timer.Interval = 3000; 
                    break;
                case "4초":
                    this.Timer.Interval = 4000;
                    break;
                case "5초":
                    this.Timer.Interval = 5000;
                    break;
            }
        }
    }
}
