﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.NetworkInformation;
using System.Runtime.InteropServices;
using System.Threading;

namespace mook_NetworkScanner
{
    public partial class Form1 : Form
    {

        [DllImport("iphlpapi.dll", ExactSpelling = true)]
        static extern int SendARP(int DestIP, int SrcIP, 
            byte[] pMacAddr, ref uint PhyAddrLen);

        Thread NetworkScan = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            NetworkScan = new Thread(NetworkCheck);
            NetworkScan.Start();
        }

        private void NetworkCheck()
        {
            try
            {
                this.lvScan.Items.Clear();

                Application.DoEvents();

                IPAddress ip = IPAddress.Parse(this.txtStart.Text);
                IPAddress ip2 = IPAddress.Parse(this.txtEnd.Text);
                IPAddress ipScan = null;
                string hostname = null;

                int[] aa = new int[4], bb = new int[4];

                aa[0] = Convert.ToInt32(ip.GetAddressBytes()[0]);
                aa[1] = Convert.ToInt32(ip.GetAddressBytes()[1]);
                aa[2] = Convert.ToInt32(ip.GetAddressBytes()[2]);
                aa[3] = Convert.ToInt32(ip.GetAddressBytes()[3]);

                bb[0] = Convert.ToInt32(ip2.GetAddressBytes()[0]);
                bb[1] = Convert.ToInt32(ip2.GetAddressBytes()[1]);
                bb[2] = Convert.ToInt32(ip2.GetAddressBytes()[2]);
                bb[3] = Convert.ToInt32(ip2.GetAddressBytes()[3]);

                this.pgrScan.Minimum = Convert.ToInt32(ip.GetAddressBytes()[3]);
                this.pgrScan.Maximum = Convert.ToInt32(ip2.GetAddressBytes()[3]);
                this.pgrScan.Value = Convert.ToInt32(ip.GetAddressBytes()[3]);
                for (int a = aa[0]; a <= bb[0]; a++)
                {
                    for (int b = aa[1]; b <= bb[1]; b++)
                    {
                        for (int c = aa[2]; c <= bb[2]; c++)
                        {
                            for (int d = aa[3]; d <= bb[3]; d++)
                            {
                                this.pgrScan.Value = d;
                                ipScan = IPAddress.Parse(a.ToString() + "." 
                                    + b.ToString() + "." + c.ToString() + "." 
                                    + d.ToString());
                                Ping pingSender = new Ping();
                                PingOptions options = new PingOptions();
                                options.DontFragment = true;
                                string data = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
                                byte[] buffer = Encoding.ASCII.GetBytes(data);
                                int timeout = 150;
                                PingReply reply = pingSender.Send(ipScan, timeout, 
                                    buffer, options);
                                hostname = null;
                                string macaddr = null;
                                if (reply.Status == IPStatus.Success)
                                {
                                    hostname = GetHostName(ipScan);
                                    macaddr = GetMacUsingARP(ipScan.ToString());
                                    ListViewItem itm = new ListViewItem();
                                    itm.Text = ipScan.ToString();
                                    itm.SubItems.Add(hostname);
                                    itm.SubItems.Add(macaddr);
                                    this.lvScan.Items.Add(itm);
                                }
                                if (d == this.pgrScan.Maximum)
                                    MessageBox.Show("네트워크 스캔을 완료하였습니다.", 
                                        "알림", MessageBoxButtons.OK, 
                                        MessageBoxIcon.Information);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "에러", 
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            { NetworkScan.Abort(); }
        }

        private string GetHostName(IPAddress pAddress)
        {
            try
            {
                IPHostEntry entry = Dns.GetHostEntry(pAddress);
                return entry.HostName;
            }
            catch (Exception)
            {
                return pAddress.ToString();
            }
        }

        private string GetMacUsingARP(string IPAddr)
        {
            IPAddress IP = IPAddress.Parse(IPAddr);
            byte[] macAddr = new byte[6];
            uint macAddrLen = (uint)macAddr.Length;
            if (SendARP((int)IP.Address, 0, macAddr, ref macAddrLen) != 0)
                return "ARP command failed";
            string[] str = new string[(int)macAddrLen];
            for (int i = 0; i < macAddrLen; i++)
                str[i] = macAddr[i].ToString("x2");
            return string.Join(":", str);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (NetworkScan != null)
                NetworkScan.Abort();
        }
    }
}
