﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Security.Cryptography;

namespace mook_TCPClient
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private TcpClient client; //TCP 네트워크 서비스에 대한 클라이언트 연결 제공
        private NetworkStream myStream; //네트워크 스트림
        private StreamReader myRead; //스트림 읽기
        private Thread myReader; //스레드

        private TripleDESCryptoServiceProvider Tdes =
            new TripleDESCryptoServiceProvider();
        private byte[] PrivateKey = new byte[] {98, 45, 125, 56, 1, 60, 
                                                11, 38, 123, 54, 234, 
                                                9, 76, 20, 44, 7, 12, 
                                                223, 219, 95, 48, 156, 
                                                32, 239};
        private byte[] PrivateIV = new byte[] { 67, 12, 3, 41, 66, 78, 
                                                34, 123 };

        private byte[] RPrivateKey = null;
        private byte[] RPrivateIV = null;

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                client = new TcpClient("127.0.0.1", 2014);
                MessageView("서버에 접속 했습니다.");
                myStream = client.GetStream();

                myRead = new StreamReader(myStream);

                myReader = new Thread(Receive);
                myReader.Start();
            }
            catch
            {
                MessageView("서버에 접속하지 못 했습니다.");
            }
        }

        private void MessageView(string strText)
        {
            this.txtMessage.AppendText(strText + "\r\n");
            this.txtMessage.Focus();
            this.txtMessage.ScrollToCaret();
        }

        private string Decrypt(string strDecrypt)
        {
            string decrypted = null;
            byte[] code = Convert.FromBase64String(strDecrypt);
            decrypted = UTF8Encoding.UTF8.GetString(Tdes.CreateDecryptor(PrivateKey,
                PrivateIV).TransformFinalBlock(code, 0, code.Length));
            RPrivate(Convert.ToInt32(decrypted.Substring(0, 1)));
            code = Convert.FromBase64String(decrypted.Substring(1, decrypted.Length-1));
            decrypted = UTF8Encoding.UTF8.GetString(Tdes.CreateDecryptor(RPrivateKey,
                RPrivateIV).TransformFinalBlock(code, 0, code.Length));
            return decrypted;
        }

        private void Receive()
        {
            try
            {
                while (true)
                {
                    if (myStream.CanRead)
                    {
                        var msg = myRead.ReadLine();
                        if (msg.Length > 0)
                        {
                            msg = Decrypt(msg);
                            MessageView(msg);
                        }
                    }
                }
            }
            catch { }
        }

        private void RPrivate(int rn)
        {
            RPrivateKey = new byte[PrivateKey.Length];
            RPrivateIV = new byte[PrivateIV.Length];
            for (int k = 0; k < PrivateKey.Length; k++)
            {
                int tmpN = (int)PrivateKey[k];
                RPrivateKey[k] = Convert.ToByte(tmpN / rn);
            }
            for (int i = 0; i < PrivateIV.Length; i++)
            {
                int tmpN = (int)PrivateIV[i];
                RPrivateIV[i] = Convert.ToByte(tmpN / rn);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                if (!(myRead == null))
                {
                    myRead.Close();
                }
                if (!(myStream == null))
                {
                    myStream.Close();
                }
                if (!(client == null))
                {
                    client.Close();
                }
                if (!(myReader == null))
                {
                    myReader.Abort();
                }
            }
            catch
            {
                return;
            }
            Application.ExitThread();
        }
    }
}